// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.
package models

import (
	"errors"
	"leit.com/LAPP_GAAS_GFrame/db"
	"time"
	"xorm.io/core"
)

type OMWorkorderqtyreclst struct {
	Plantnr            int       `json:"PlantNr" xorm:"not null pk INT(4)"`
	Workorderid        string    `json:"WorkOrderId" xorm:"not null pk NVARCHAR(40)"`
	Pos                int       `json:"Pos" xorm:"not null pk INT(4)"`
	Actqty             float32   `json:"ActQty" xorm:"not null FLOAT(8)"`
	Orderqtytype       string    `json:"OrderQtyType" xorm:"not null pk NVARCHAR(40)"`
	Recordtime         time.Time `json:"RecordTime" xorm:"DATETIME(8)"`
	Triggerevent       		string    `json:"TriggerEvent" xorm:"not null NVARCHAR(40)"`
	Triggerobjectid    		string    `json:"TriggerObjectId" xorm:"not null NVARCHAR(40)"`
	Triggersubobjectid 		string    `json:"TriggerSubObjectId" xorm:"not null NVARCHAR(40)"`
	Outputstatus         	int       `json:"OutputStatus" xorm:"not null INT(4)"`
	Outputevent       		string    `json:"OutputEvent" xorm:"not null NVARCHAR(40)"`
	Outputeventmessageid    string    `json:"OutputEventMessageId" xorm:"not null NVARCHAR(40)"`
	Outputobjectid 			string    `json:"OutputObjectId" xorm:"not null NVARCHAR(40)"`
	Outputsubobjectid 		string    `json:"OutputSubObjectId" xorm:"not null NVARCHAR(40)"`
	Remark1            string    `json:"Remark1" xorm:"not null pk NVARCHAR(80)"`
	Remark2            string    `json:"Remark2" xorm:"not null pk NVARCHAR(80)"`
	Lastmodify         time.Time `json:"LastModify" xorm:"DATETIME(8)"`
	Lastuser           string    `json:"LastUser" xorm:"not null NVARCHAR(40)"`
	Createtime         time.Time `json:"CreateTime" xorm:"DATETIME(8)"`
	Itemlst 		   []Daymodel `json:"itemlst" xorm:"-"`
}

/******数据表名******/
func (t *OMWorkorderqtyreclst) TableName() string {
	return "OMWorkOrderQtyRecLst"
}

/******************************************************************************
 *
 * @Function Name      :
 *-----------------------------------------------------------------------------
 *
 * @Description        : 数据添加
 *
 * @Function Parameters:
 *
 * @Return Value       :
 *
 * @Author             : Lou Wenzhi
 *
 * @Date               : 2021/3/6 8:47
 *
 ******************************************************************************/
func (t *OMWorkorderqtyreclst) Add() error {
	e := db.Eloquent.Master()
	wotab := new(OMWorkorderqtyreclst)
	/**主键：****/
	affw, err := e.Table(t.TableName()).ID(core.PK{t.Plantnr, t.Workorderid, t.Pos}).Count(wotab)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table(t.TableName()).Insert(t)

	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Function Name      :
 *-----------------------------------------------------------------------------
 *
 * @Description        : 数据删除
 *
 * @Function Parameters:
 *
 * @Return Value       :
 *
 * @Author             : Lou Wenzhi
 *
 * @Date               : 2021/3/6 8:47
 *
 ******************************************************************************/
func (t *OMWorkorderqtyreclst) Del() error {
	e := db.Eloquent.Master()
	/**主键：****/
	_, err := e.ID(core.PK{t.Plantnr, t.Workorderid, t.Pos}).Delete(&OMWorkorderqtyreclst{})
	if err != nil {
		return errors.New("删除失败！")
	}
	return nil
}

/******************************************************************************
 *
 * @Function Name      :
 *-----------------------------------------------------------------------------
 *
 * @Description        : 数据修改
 *
 * @Function Parameters:
 *
 * @Return Value       :
 *
 * @Author             : Lou Wenzhi
 *
 * @Date               : 2021/3/6 8:47
 *
 ******************************************************************************/
func (t *OMWorkorderqtyreclst) Update() error {
	e := db.Eloquent.Master()
	/**主键：****/
	_, err := e.ID(core.PK{t.Plantnr, t.Workorderid, t.Pos}).Update(t)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Function Name      :
 *-----------------------------------------------------------------------------
 *
 * @Description        : 数据查找
 *
 * @Function Parameters:
 *
 * @Return Value       :
 *
 * @Author             : Lou Wenzhi
 *
 * @Date               : 2021/3/6 8:47
 *
 ******************************************************************************/
func (t *OMWorkorderqtyreclst) SelectOne() (OMWorkorderqtyreclst, error) {
	e := db.Eloquent.Master()
	var data OMWorkorderqtyreclst
	/**主键：****/
	_, err := e.ID(core.PK{t.Plantnr, t.Workorderid, t.Pos}).Get(&data)
	if err != nil {
		return data, err
	}
	return data, nil
}
