// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.
package models

import (
	"leit.com/LAPP_GAAS_GFrame/db"
	"errors"
	"xorm.io/core"
)

type Weekmodellst struct {
	Plantnr     int 	`json:"PlantNr" xorm:"not null pk INT(4)"`
	Weekmodelnr int 	`json:"WeekModelNr" xorm:"not null pk INT(4)"`
	Workdate    string 	`json:"WorkDate" xorm:"not null pk NVARCHAR(8)"`
	Daymodelnr  int 	`json:"DayModelNr" xorm:"not null INT(4)"`
}

/******数据表名******/
func (t *Weekmodellst) TableName() string {
	return "WeekModelLst"
}

/******************************************************************************
 *
 * @Function Name      :
 *-----------------------------------------------------------------------------
 *
 * @Description        : 数据添加
 *
 * @Function Parameters:
 *
 * @Return Value       :
 *
 * @Author             : Lou Wenzhi
 *
 * @Date               : 2021/3/6 8:47
 *
 ******************************************************************************/
func (t *Weekmodellst) Add() error {
	e := db.Eloquent.Master()
	count := new(Weekmodellst)
	affw, err := e.Table(t.TableName()).ID(core.PK{t.Plantnr, t.Weekmodelnr, t.Workdate}).Count(count)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table(t.TableName()).Insert(t)

	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Function Name      :
 *-----------------------------------------------------------------------------
 *
 * @Description        : 数据删除
 *
 * @Function Parameters:
 *
 * @Return Value       :
 *
 * @Author             : Lou Wenzhi
 *
 * @Date               : 2021/3/6 8:47
 *
 ******************************************************************************/
func (t *Weekmodellst) Del() bool {
	e := db.Eloquent.Master()
	_, err := e.ID(core.PK{t.Plantnr, t.Weekmodelnr, t.Workdate}).Delete(&Weekmodellst{})
	if err != nil {
		return false
	}
	return true
}

/******************************************************************************
 *
 * @Function Name      :
 *-----------------------------------------------------------------------------
 *
 * @Description        : 数据修改
 *
 * @Function Parameters:
 *
 * @Return Value       :
 *
 * @Author             : Lou Wenzhi
 *
 * @Date               : 2021/3/6 8:47
 *
 ******************************************************************************/
func (t *Weekmodellst) Update() error {
	e := db.Eloquent.Master()
	_, err := e.ID(core.PK{t.Plantnr, t.Weekmodelnr, t.Workdate}).Update(t)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Function Name      :
 *-----------------------------------------------------------------------------
 *
 * @Description        : 数据查找
 *
 * @Function Parameters:
 *
 * @Return Value       :
 *
 * @Author             : Lou Wenzhi
 *
 * @Date               : 2021/3/6 8:47
 *
 ******************************************************************************/
func (t *Weekmodellst) SelectOne() (Weekmodellst, error) {
	e := db.Eloquent.Master()
	var data Weekmodellst
	_, err := e.ID(core.PK{t.Plantnr, t.Weekmodelnr, t.Workdate}).Get(&data)
	if err != nil {
		return data, err
	}
	return data, nil
}
