package schedule

import (
	"strconv"
	"strings"
	"time"
)

func Max(vals ...int) int {
	var max int
	for _, val := range vals {
		if val > max {
			max = val
		}
	}
	return max
}

func Min(vals ...int) int {
	var min int
	for _, val := range vals {
		if min == 0 || val <= min {
			min = val
		}
	}
	return min
}

func MaxTime(vals ...time.Time) time.Time {
	var max time.Time

	if len(vals) > 0 {
		max = vals[0]
	}else{
		// 默认返回一年前的时间
		return time.Now().Add(24*265*time.Second)
	}

	for _, val := range vals {
		if val.Unix() > max.Unix() {
			max = val
		}
	}
	return max
}

func MinTime(vals ...time.Time) time.Time {
	var min time.Time

	if len(vals) > 0 {
		min = vals[0]
	}else{
		// 默认返回一年前的时间
		return time.Now().Add(24*265*time.Second)
	}

	for _, val := range vals {
		if val.Unix() <= min.Unix() {
			min = val
		}
	}
	return min
}

// 将给定的整数值转换成给定长度的字符串，不足长度的在前面补足0
func ConvInt2FormatString(input, ilen int) (retstring string) {
	var igap int

	if len(string(input)) >= ilen {
		retstring = string(input)
	} else {
		igap = ilen - len(strconv.Itoa(input))
		retstring = strings.Repeat("0", igap) + strconv.Itoa(input)
	}
	return
}
