package schedule

import "time"

type WorkLoadSrv struct {
	LoadType 		string
	StartTime		time.Time
	EndTime			time.Time
	AvailCapacity 	time.Duration
	RestCapacity	time.Duration
	WorkLoadPercent float64
}

func(wloadsrv *WorkLoadSrv)Init(){
	if wloadsrv.AvailCapacity <= 0 {
		wloadsrv.WorkLoadPercent = 0.0
		return
	}
	// 时段负荷 = （可用能力 - 剩余能力）/可用能力
	wloadsrv.WorkLoadPercent = ( wloadsrv.AvailCapacity.Seconds() - wloadsrv.RestCapacity.Seconds() ) / wloadsrv.AvailCapacity.Seconds()
	return
}
