package log

import (
	"github.com/kataras/iris/v12/core/router"
)

func Register(party router.Party) {
	party = party.Party("/log")

	// log_packorder
	log_packorder := party.Party("/log_packorder")

	// log_packorder Select
	log_packorder.Get("/", SelectPackOrder)
	log_packorder.Get("/{packOrderId:string}", SelectOnePackOrder)

	// log_packorderitemlst
	log_packorderitemlst := party.Party("/log_packorderitemlst")

	// log_packorderitemlst Select
	log_packorderitemlst.Get("/", SelectPackOrderItemlst)
	log_packorderitemlst.Get("/{packOrderId:string}/{pos:int}", SelectOnePackOrderItemlst)

	// log_packtemplate
	log_packtemplate := party.Party("/log_packtemplate")

	// log_packtemplate Select
	log_packtemplate.Get("/", SelectPackTemplate)
	log_packtemplate.Get("/{packTemplateId:string}", SelectOnePackTemplate)

	// log_packtemplateitemlst
	log_packtemplateitemlst := party.Party("/log_packtemplateitemlst")

	// log_packtemplateitemlst Select
	log_packtemplateitemlst.Get("/", SelectPackTemplateItemlst)
	log_packtemplateitemlst.Get("/{packTemplateId:string}/{pos:int}", SelectOnePackTemplateItemlst)

	// log_packtemplateprintlst
	log_packtemplateprintlst := party.Party("/log_packtemplateprintlst")

	// log_packtemplateprintlst Select
	log_packtemplateprintlst.Get("/", SelectPackTemplatePrintlst)
	log_packtemplateprintlst.Get("/{packTemplateId:string}/{pos:int}", SelectOnePackTemplatePrintlst)

	// log_packtype
	log_packtype := party.Party("/log_packtype")

	// log_packtype Select
	log_packtype.Get("/", SelectPackType)
	log_packtype.Get("/{packTypeId:string}", SelectOnePackType)
}
