package qm

import (
	"github.com/kataras/iris/v12/core/router"
)

func Register(party router.Party) {
	party = party.Party("/qm")

	// qm_artview
	qm_artview := party.Party("/qm_artview")

	// qm_artview Select
	qm_artview.Get("/", SelectArtView)
	qm_artview.Get("/{artId:string}/{viewId:string}", SelectOneArtView)

	// qm_view
	qm_view := party.Party("/qm_view")

	// qm_view Select
	qm_view.Get("/", SelectView)
	qm_view.Get("/{viewId:string}", SelectOneView)

	// qm_defectrecord
	qm_defectrecord := party.Party("/qm_defectrecord")

	// qm_defectrecord Select
	qm_defectrecord.Get("/", SelectDefectRecord)
	qm_defectrecord.Get("/{recNr:int}", SelectOneDefectRecord)

	// qm_viewvalst
	qm_viewvalst := party.Party("/qm_viewvalst")

	// qm_viewvalst Select
	qm_viewvalst.Get("/", SelectViewValst)
	qm_viewvalst.Get("/{viewId:string}/{pos:int}", SelectOneViewValst)

	// qm_viewdefectgrplst
	qm_viewdefectgrplst := party.Party("/qm_viewdefectgrplst")

	// qm_viewdefectgrplst Select
	qm_viewdefectgrplst.Get("/", SelectViewDefectGrplst)
	qm_viewdefectgrplst.Get("/{viewId:string}/{defectGrpId:string}", SelectOneViewDefectGrplst)

	// qm_viewdefectlst
	qm_viewdefectlst := party.Party("/qm_viewdefectlst")

	// qm_viewdefectlst Select
	qm_viewdefectlst.Get("/", SelectViewDefectlst)
	qm_viewdefectlst.Get("/{viewId:string}/{defectReasonId:string}", SelectOneViewDefectlst)

	// qm_defectgrp
	qm_defectgrp := party.Party("/qm_defectgrp")

	// qm_defectgrp Select
	qm_defectgrp.Get("/", SelectDefectGrp)
	qm_defectgrp.Get("/{defectGrpId:string}", SelectOneDefectGrp)

	// qm_defectgrpreasonlst
	qm_defectgrpreasonlst := party.Party("/qm_defectgrpreasonlst")

	// qm_defectgrpreasonlst Select
	qm_defectgrpreasonlst.Get("/", SelectDefectGrpReasonLst)
	qm_defectgrpreasonlst.Get("/{defectGrpId:string}/{defectReasonId:string}", SelectOneDefectGrpReasonLst)

	// qm_defectreason
	qm_defectreason := party.Party("/qm_defectreason")

	// qm_defectreason Select
	qm_defectreason.Get("/", SelectDefectReason)
	qm_defectreason.Get("/{defectReasonId:string}", SelectOneDefectReason)
}
