package log

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	"xorm.io/core"
)

//LOG_PackOrderItemlst的实体映射
type PackOrderItemlst struct {
	session       *xorm.Session `xorm:"-"`
	PlantNr       int           `xorm:"pk int 'PlantNr'" json:"LOG_PackOrderItemlst-PlantNr"`
	PackOrderId   string        `xorm:"pk nvarchar(40) 'PackOrderId'" json:"LOG_PackOrderItemlst-PackOrderId"`
	Pos           int           `xorm:"pk int 'Pos'" json:"LOG_PackOrderItemlst-Pos"`
	PosCode       string        `xorm:"nvarchar(40) 'PosCode' not null" json:"LOG_PackOrderItemlst-PosCode"`
	MaterialId    string        `xorm:"nvarchar(40) 'MaterialId' not null" json:"LOG_PackOrderItemlst-MaterialId"`
	SerialOrderId string        `xorm:"nvarchar(40) 'SerialOrderId' not null" json:"LOG_PackOrderItemlst-SerialOrderId"`
	PlanQty       float64       `xorm:"float 'PlanQty' not null" json:"LOG_PackOrderItemlst-PlanQty"`
	ActQty        float64       `xorm:"float 'ActQty' not null" json:"LOG_PackOrderItemlst-ActQty"`
	Status        int           `xorm:"int 'Status' not null" json:"LOG_PackOrderItemlst-Status"`
	Seq           int           `xorm:"int 'Seq' not null" json:"LOG_PackOrderItemlst-Seq"`
	PKOICustC1    string        `xorm:"nvarchar(40) 'PKOI_CustC1' not null" json:"LOG_PackOrderItemlst-PKOI_CustC1"`
	PKOICustC2    string        `xorm:"nvarchar(40) 'PKOI_CustC2' not null" json:"LOG_PackOrderItemlst-PKOI_CustC2"`
	PKOICustI1    int           `xorm:"int 'PKOI_CustI1' not null" json:"LOG_PackOrderItemlst-PKOI_CustI1"`
	PKOICustI2    int           `xorm:"int 'PKOI_CustI2' not null" json:"LOG_PackOrderItemlst-PKOI_CustI2"`
	LastModify    grmi.DateTime `xorm:"datetime 'LastModify' not null updated" json:"LOG_PackOrderItemlst-LastModify"`
	LastUser      string        `xorm:"nvarchar(20) 'LastUser' not null" json:"LOG_PackOrderItemlst-LastUser"`
	CreateTime    grmi.DateTime `xorm:"datetime 'CreateTime' not null created" json:"LOG_PackOrderItemlst-CreateTime"`
}

var MetaOfPackOrderItemlst = map[string]grmi.Field{
	"packorderid":   {"PackOrderId", "string"},
	"pos":           {"Pos", "int"},
	"poscode":       {"PosCode", "string"},
	"materialid":    {"MaterialId", "string"},
	"serialorderid": {"SerialOrderId", "string"},
	"planqty":       {"PlanQty", "float64"},
	"actqty":        {"ActQty", "float64"},
	"status":        {"Status", "int"},
	"seq":           {"Seq", "int"},
	"pkoicustc1":    {"PKOI_CustC1", "string"},
	"pkoicustc2":    {"PKOI_CustC2", "string"},
	"pkoicusti1":    {"PKOI_CustI1", "int"},
	"pkoicusti2":    {"PKOI_CustI2", "int"},
	"lastmodify":    {"LastModify", "grmi.DateTime"},
	"lastuser":      {"LastUser", "string"},
	"createtime":    {"CreateTime", "grmi.DateTime"},
}

//将PackOrderItemlst附加到xorm会话上
func (self *PackOrderItemlst) Attach(session *xorm.Session) *PackOrderItemlst {
	self.session = session
	return self
}

//插入PackOrderItemlst
func (self *PackOrderItemlst) Insert() error {
	_, err := self.session.Table("LOG_PackOrderItemlst").Insert(self)
	if err != nil {
		return err
	}
	return nil
}

//修改PackOrderItemlst
func (self *PackOrderItemlst) Update() error {
	_, err := self.session.Table("LOG_PackOrderItemlst").Cols("PosCode", "MaterialId", "SerialOrderId", "PlanQty", "ActQty", "Status", "Seq", "PKOI_CustC1", "PKOI_CustC2", "PKOI_CustI1", "PKOI_CustI2", "LastUser").Update(self)
	if err != nil {
		return err
	}
	return nil
}

//删除PackOrderItemlst
func (self *PackOrderItemlst) Delete() error {
	_, err := self.session.Table("LOG_PackOrderItemlst").Delete(self)
	if err != nil {
		return err
	}
	return nil
}

//PackOrderItemlst的表名
var Table_PackOrderItemlst = "LOG_PackOrderItemlst"

//PackOrderItemlst.PackOrderId的列名
var Column_PackOrderItemlst_PackOrderId = "PackOrderId"

//PackOrderItemlst.Pos的列名
var Column_PackOrderItemlst_Pos = "Pos"

//PackOrderItemlst.PosCode的列名
var Column_PackOrderItemlst_PosCode = "PosCode"

//PackOrderItemlst.MaterialId的列名
var Column_PackOrderItemlst_MaterialId = "MaterialId"

//PackOrderItemlst.SerialOrderId的列名
var Column_PackOrderItemlst_SerialOrderId = "SerialOrderId"

//PackOrderItemlst.PlanQty的列名
var Column_PackOrderItemlst_PlanQty = "PlanQty"

//PackOrderItemlst.ActQty的列名
var Column_PackOrderItemlst_ActQty = "ActQty"

//PackOrderItemlst.Status的列名
var Column_PackOrderItemlst_Status = "Status"

//PackOrderItemlst.Seq的列名
var Column_PackOrderItemlst_Seq = "Seq"

//PackOrderItemlst.PKOICustC1的列名
var Column_PackOrderItemlst_PKOICustC1 = "PKOI_CustC1"

//PackOrderItemlst.PKOICustC2的列名
var Column_PackOrderItemlst_PKOICustC2 = "PKOI_CustC2"

//PackOrderItemlst.PKOICustI1的列名
var Column_PackOrderItemlst_PKOICustI1 = "PKOI_CustI1"

//PackOrderItemlst.PKOICustI2的列名
var Column_PackOrderItemlst_PKOICustI2 = "PKOI_CustI2"

//PackOrderItemlst的指示器
var IndicatorOfPackOrderItemlst = &PackOrderItemlst{}

//创建PackOrderItemlst的游标
func BuildPackOrderItemlstCursor() *PackOrderItemlst {
	return &PackOrderItemlst{}
}

//查找指定键的PackOrderItemlst
func (self *DAO) SelectOnePackOrderItemlst(packOrderId string, pos int) (*PackOrderItemlst, error) {
	var data PackOrderItemlst
	ok, err := self.session.Table("LOG_PackOrderItemlst").ID(core.PK{self.plantNr, packOrderId, pos}).Get(&data)
	if err != nil {
		return nil, err
	}
	if !ok {
		return nil, err
	}
	return &data, nil
}

//删除指定键的PackOrderItemlst
func (self *DAO) DeleteOnePackOrderItemlst(packOrderId string, pos int) error {
	_, err := self.session.Table("LOG_PackOrderItemlst").ID(core.PK{self.plantNr, packOrderId, pos}).Delete(IndicatorOfPackOrderItemlst)
	if err != nil {
		return err
	}
	return nil
}

//批量检查PackOrderItemlst
func (self *DAO) checkPackOrderItemlstRecords(records *[]PackOrderItemlst) error {
	for _, record := range *records {
		if self.plantNr != record.PlantNr {
			return errors.New("记录不在范围内!")
		}
	}
	return nil
}

//插入多条PackOrderItemlst
func (self *DAO) InsertPackOrderItemlst(records *[]PackOrderItemlst) error {
	err := self.checkPackOrderItemlstRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("LOG_PackOrderItemlst").Insert(records)
	if err != nil {
		return err
	}
	return nil
}

//修改多条PackOrderItemlst
func (self *DAO) UpdatePackOrderItemlst(records *[]PackOrderItemlst) error {
	err := self.checkPackOrderItemlstRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("LOG_PackOrderItemlst").Cols("PosCode", "MaterialId", "SerialOrderId", "PlanQty", "ActQty", "Status", "Seq", "PKOI_CustC1", "PKOI_CustC2", "PKOI_CustI1", "PKOI_CustI2", "LastUser").Update(records)
	if err != nil {
		return err
	}
	return nil
}

//删除多条PackOrderItemlst
func (self *DAO) DeletePackOrderItemlst(records *[]PackOrderItemlst) error {
	err := self.checkPackOrderItemlstRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("LOG_PackOrderItemlst").Delete(records)
	if err != nil {
		return err
	}
	return nil
}

//按条件查询PackOrderItemlst
func (self *DAO) SelectPackOrderItemlst(predicates []grmi.Predicate) ([]PackOrderItemlst, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)
	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += " and " + predicate.ColumnName + " = ?"
			parameters = append(parameters, predicate.Value)
		}
	}
	data := make([]PackOrderItemlst, 0)
	err := self.session.Table("LOG_PackOrderItemlst").Where("PlantNr = ?"+where, parameters...).OrderBy("PlantNr").OrderBy("PackOrderId").OrderBy("Pos").Find(&data)
	if err != nil {
		return nil, err
	}
	return data, nil
}

//按条件查询PackOrderItemlst并分页
func (self *DAO) SelectPackOrderItemlstAndPaging(pageSize int, pageIndex int, predicates []grmi.Predicate) (grmi.PagingResult, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)
	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += " and " + predicate.ColumnName + " = ?"
			parameters = append(parameters, predicate.Value)
		}
	}
	parameters = append(parameters, (pageIndex-1)*pageSize, pageSize)
	data := make([]PackOrderItemlst, 0)
	err := self.session.Table("LOG_PackOrderItemlst").SQL("select * from LOG_PackOrderItemlst where PlantNr = ?"+where+" order by PlantNr, PackOrderId, Pos offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.PagingResult{}, err
	}
	count, err := self.session.Table("LOG_PackOrderItemlst").Where("PlantNr = ? ", self.plantNr).Count(IndicatorOfPackOrderItemlst)
	if err != nil {
		return grmi.PagingResult{}, err
	}
	return grmi.PagingResult{data, count, pageIndex, pageSize}, nil
}
