package log

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	"xorm.io/core"
)

//LOG_PackTemplateItemlst的实体映射
type PackTemplateItemlst struct {
	session        *xorm.Session `xorm:"-"`
	PlantNr        int           `xorm:"pk int 'PlantNr'" json:"LOG_PackTemplateItemlst-PlantNr"`
	PackTemplateId string        `xorm:"pk nvarchar(40) 'PackTemplateId'" json:"LOG_PackTemplateItemlst-PackTemplateId"`
	Pos            int           `xorm:"pk int 'Pos'" json:"LOG_PackTemplateItemlst-Pos"`
	PosCode        string        `xorm:"nvarchar(40) 'PosCode' not null" json:"LOG_PackTemplateItemlst-PosCode"`
	MaterialId     string        `xorm:"nvarchar(40) 'MaterialId' not null" json:"LOG_PackTemplateItemlst-MaterialId"`
	Seq            int           `xorm:"int 'Seq' not null" json:"LOG_PackTemplateItemlst-Seq"`
	PlanQty        int           `xorm:"int 'PlanQty' not null" json:"LOG_PackTemplateItemlst-PlanQty"`
	PKTMPICustC1   string        `xorm:"nvarchar(40) 'PKTMPI_CustC1' not null" json:"LOG_PackTemplateItemlst-PKTMPI_CustC1"`
	PKTMPICustC2   string        `xorm:"nvarchar(40) 'PKTMPI_CustC2' not null" json:"LOG_PackTemplateItemlst-PKTMPI_CustC2"`
	PKTMPICustI1   int           `xorm:"int 'PKTMPI_CustI1' not null" json:"LOG_PackTemplateItemlst-PKTMPI_CustI1"`
	PKTMPICustI2   int           `xorm:"int 'PKTMPI_CustI2' not null" json:"LOG_PackTemplateItemlst-PKTMPI_CustI2"`
	LastModify     grmi.DateTime `xorm:"datetime 'LastModify' not null updated" json:"LOG_PackTemplateItemlst-LastModify"`
	LastUser       string        `xorm:"nvarchar(20) 'LastUser' not null" json:"LOG_PackTemplateItemlst-LastUser"`
	CreateTime     grmi.DateTime `xorm:"datetime 'CreateTime' not null created" json:"LOG_PackTemplateItemlst-CreateTime"`
}

var MetaOfPackTemplateItemlst = map[string]grmi.Field{
	"packtemplateid": {"PackTemplateId", "string"},
	"pos":            {"Pos", "int"},
	"poscode":        {"PosCode", "string"},
	"materialid":     {"MaterialId", "string"},
	"seq":            {"Seq", "int"},
	"planqty":        {"PlanQty", "int"},
	"pktmpicustc1":   {"PKTMPI_CustC1", "string"},
	"pktmpicustc2":   {"PKTMPI_CustC2", "string"},
	"pktmpicusti1":   {"PKTMPI_CustI1", "int"},
	"pktmpicusti2":   {"PKTMPI_CustI2", "int"},
	"lastmodify":     {"LastModify", "grmi.DateTime"},
	"lastuser":       {"LastUser", "string"},
	"createtime":     {"CreateTime", "grmi.DateTime"},
}

//将PackTemplateItemlst附加到xorm会话上
func (self *PackTemplateItemlst) Attach(session *xorm.Session) *PackTemplateItemlst {
	self.session = session
	return self
}

//插入PackTemplateItemlst
func (self *PackTemplateItemlst) Insert() error {
	_, err := self.session.Table("LOG_PackTemplateItemlst").Insert(self)
	if err != nil {
		return err
	}
	return nil
}

//修改PackTemplateItemlst
func (self *PackTemplateItemlst) Update() error {
	_, err := self.session.Table("LOG_PackTemplateItemlst").Cols("PosCode", "MaterialId", "Seq", "PlanQty", "PKTMPI_CustC1", "PKTMPI_CustC2", "PKTMPI_CustI1", "PKTMPI_CustI2", "LastUser").Update(self)
	if err != nil {
		return err
	}
	return nil
}

//删除PackTemplateItemlst
func (self *PackTemplateItemlst) Delete() error {
	_, err := self.session.Table("LOG_PackTemplateItemlst").Delete(self)
	if err != nil {
		return err
	}
	return nil
}

//PackTemplateItemlst的表名
var Table_PackTemplateItemlst = "LOG_PackTemplateItemlst"

//PackTemplateItemlst.PackTemplateId的列名
var Column_PackTemplateItemlst_PackTemplateId = "PackTemplateId"

//PackTemplateItemlst.Pos的列名
var Column_PackTemplateItemlst_Pos = "Pos"

//PackTemplateItemlst.PosCode的列名
var Column_PackTemplateItemlst_PosCode = "PosCode"

//PackTemplateItemlst.MaterialId的列名
var Column_PackTemplateItemlst_MaterialId = "MaterialId"

//PackTemplateItemlst.Seq的列名
var Column_PackTemplateItemlst_Seq = "Seq"

//PackTemplateItemlst.PlanQty的列名
var Column_PackTemplateItemlst_PlanQty = "PlanQty"

//PackTemplateItemlst.PKTMPICustC1的列名
var Column_PackTemplateItemlst_PKTMPICustC1 = "PKTMPI_CustC1"

//PackTemplateItemlst.PKTMPICustC2的列名
var Column_PackTemplateItemlst_PKTMPICustC2 = "PKTMPI_CustC2"

//PackTemplateItemlst.PKTMPICustI1的列名
var Column_PackTemplateItemlst_PKTMPICustI1 = "PKTMPI_CustI1"

//PackTemplateItemlst.PKTMPICustI2的列名
var Column_PackTemplateItemlst_PKTMPICustI2 = "PKTMPI_CustI2"

//PackTemplateItemlst的指示器
var IndicatorOfPackTemplateItemlst = &PackTemplateItemlst{}

//创建PackTemplateItemlst的游标
func BuildPackTemplateItemlstCursor() *PackTemplateItemlst {
	return &PackTemplateItemlst{}
}

//查找指定键的PackTemplateItemlst
func (self *DAO) SelectOnePackTemplateItemlst(packTemplateId string, pos int) (*PackTemplateItemlst, error) {
	var data PackTemplateItemlst
	ok, err := self.session.Table("LOG_PackTemplateItemlst").ID(core.PK{self.plantNr, packTemplateId, pos}).Get(&data)
	if err != nil {
		return nil, err
	}
	if !ok {
		return nil, err
	}
	return &data, nil
}

//删除指定键的PackTemplateItemlst
func (self *DAO) DeleteOnePackTemplateItemlst(packTemplateId string, pos int) error {
	_, err := self.session.Table("LOG_PackTemplateItemlst").ID(core.PK{self.plantNr, packTemplateId, pos}).Delete(IndicatorOfPackTemplateItemlst)
	if err != nil {
		return err
	}
	return nil
}

//批量检查PackTemplateItemlst
func (self *DAO) checkPackTemplateItemlstRecords(records *[]PackTemplateItemlst) error {
	for _, record := range *records {
		if self.plantNr != record.PlantNr {
			return errors.New("记录不在范围内!")
		}
	}
	return nil
}

//插入多条PackTemplateItemlst
func (self *DAO) InsertPackTemplateItemlst(records *[]PackTemplateItemlst) error {
	err := self.checkPackTemplateItemlstRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("LOG_PackTemplateItemlst").Insert(records)
	if err != nil {
		return err
	}
	return nil
}

//修改多条PackTemplateItemlst
func (self *DAO) UpdatePackTemplateItemlst(records *[]PackTemplateItemlst) error {
	err := self.checkPackTemplateItemlstRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("LOG_PackTemplateItemlst").Cols("PosCode", "MaterialId", "Seq", "PlanQty", "PKTMPI_CustC1", "PKTMPI_CustC2", "PKTMPI_CustI1", "PKTMPI_CustI2", "LastUser").Update(records)
	if err != nil {
		return err
	}
	return nil
}

//删除多条PackTemplateItemlst
func (self *DAO) DeletePackTemplateItemlst(records *[]PackTemplateItemlst) error {
	err := self.checkPackTemplateItemlstRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("LOG_PackTemplateItemlst").Delete(records)
	if err != nil {
		return err
	}
	return nil
}

//按条件查询PackTemplateItemlst
func (self *DAO) SelectPackTemplateItemlst(predicates []grmi.Predicate) ([]PackTemplateItemlst, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)
	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += " and " + predicate.ColumnName + " = ?"
			parameters = append(parameters, predicate.Value)
		}
	}
	data := make([]PackTemplateItemlst, 0)
	err := self.session.Table("LOG_PackTemplateItemlst").Where("PlantNr = ?"+where, parameters...).OrderBy("PlantNr").OrderBy("PackTemplateId").OrderBy("Pos").Find(&data)
	if err != nil {
		return nil, err
	}
	return data, nil
}

//按条件查询PackTemplateItemlst并分页
func (self *DAO) SelectPackTemplateItemlstAndPaging(pageSize int, pageIndex int, predicates []grmi.Predicate) (grmi.PagingResult, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)
	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += " and " + predicate.ColumnName + " = ?"
			parameters = append(parameters, predicate.Value)
		}
	}
	parameters = append(parameters, (pageIndex-1)*pageSize, pageSize)
	data := make([]PackTemplateItemlst, 0)
	err := self.session.Table("LOG_PackTemplateItemlst").SQL("select * from LOG_PackTemplateItemlst where PlantNr = ?"+where+" order by PlantNr, PackTemplateId, Pos offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.PagingResult{}, err
	}
	count, err := self.session.Table("LOG_PackTemplateItemlst").Where("PlantNr = ? ", self.plantNr).Count(IndicatorOfPackTemplateItemlst)
	if err != nil {
		return grmi.PagingResult{}, err
	}
	return grmi.PagingResult{data, count, pageIndex, pageSize}, nil
}
