package log

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	"xorm.io/core"
)

//LOG_PackTemplatePrintlst的实体映射
type PackTemplatePrintlst struct {
	session        *xorm.Session `xorm:"-"`
	PlantNr        int           `xorm:"pk int 'PlantNr'" json:"LOG_PackTemplatePrintlst-PlantNr"`
	PackTemplateId string        `xorm:"pk nvarchar(40) 'PackTemplateId'" json:"LOG_PackTemplatePrintlst-PackTemplateId"`
	Pos            int           `xorm:"pk int 'Pos'" json:"LOG_PackTemplatePrintlst-Pos"`
	VarName        string        `xorm:"nvarchar(20) 'VarName' not null" json:"LOG_PackTemplatePrintlst-VarName"`
	VarValue       string        `xorm:"nvarchar(100) 'VarValue' not null" json:"LOG_PackTemplatePrintlst-VarValue"`
	VarType        string        `xorm:"nvarchar(10) 'VarType' not null" json:"LOG_PackTemplatePrintlst-VarType"`
	VarPos         string        `xorm:"nvarchar(20) 'VarPos' not null" json:"LOG_PackTemplatePrintlst-VarPos"`
	Picture        string        `xorm:"nvarchar(40) 'Picture' not null" json:"LOG_PackTemplatePrintlst-Picture"`
	IsIdxToggle    bool          `xorm:"bit 'IsIdxToggle' not null" json:"LOG_PackTemplatePrintlst-IsIdxToggle"`
	KeyVal         string        `xorm:"nvarchar(40) 'KeyVal' not null" json:"LOG_PackTemplatePrintlst-KeyVal"`
	LastModify     grmi.DateTime `xorm:"datetime 'LastModify' not null updated" json:"LOG_PackTemplatePrintlst-LastModify"`
	LastUser       string        `xorm:"nvarchar(20) 'LastUser' not null" json:"LOG_PackTemplatePrintlst-LastUser"`
	CreateTime     grmi.DateTime `xorm:"datetime 'CreateTime' not null created" json:"LOG_PackTemplatePrintlst-CreateTime"`
}

var MetaOfPackTemplatePrintlst = map[string]grmi.Field{
	"packtemplateid": {"PackTemplateId", "string"},
	"pos":            {"Pos", "int"},
	"varname":        {"VarName", "string"},
	"varvalue":       {"VarValue", "string"},
	"vartype":        {"VarType", "string"},
	"varpos":         {"VarPos", "string"},
	"picture":        {"Picture", "string"},
	"isidxtoggle":    {"IsIdxToggle", "bool"},
	"keyval":         {"KeyVal", "string"},
	"lastmodify":     {"LastModify", "grmi.DateTime"},
	"lastuser":       {"LastUser", "string"},
	"createtime":     {"CreateTime", "grmi.DateTime"},
}

//将PackTemplatePrintlst附加到xorm会话上
func (self *PackTemplatePrintlst) Attach(session *xorm.Session) *PackTemplatePrintlst {
	self.session = session
	return self
}

//插入PackTemplatePrintlst
func (self *PackTemplatePrintlst) Insert() error {
	_, err := self.session.Table("LOG_PackTemplatePrintlst").Insert(self)
	if err != nil {
		return err
	}
	return nil
}

//修改PackTemplatePrintlst
func (self *PackTemplatePrintlst) Update() error {
	_, err := self.session.Table("LOG_PackTemplatePrintlst").Cols("VarName", "VarValue", "VarType", "VarPos", "Picture", "IsIdxToggle", "KeyVal", "LastUser").Update(self)
	if err != nil {
		return err
	}
	return nil
}

//删除PackTemplatePrintlst
func (self *PackTemplatePrintlst) Delete() error {
	_, err := self.session.Table("LOG_PackTemplatePrintlst").Delete(self)
	if err != nil {
		return err
	}
	return nil
}

//PackTemplatePrintlst的表名
var Table_PackTemplatePrintlst = "LOG_PackTemplatePrintlst"

//PackTemplatePrintlst.PackTemplateId的列名
var Column_PackTemplatePrintlst_PackTemplateId = "PackTemplateId"

//PackTemplatePrintlst.Pos的列名
var Column_PackTemplatePrintlst_Pos = "Pos"

//PackTemplatePrintlst.VarName的列名
var Column_PackTemplatePrintlst_VarName = "VarName"

//PackTemplatePrintlst.VarValue的列名
var Column_PackTemplatePrintlst_VarValue = "VarValue"

//PackTemplatePrintlst.VarType的列名
var Column_PackTemplatePrintlst_VarType = "VarType"

//PackTemplatePrintlst.VarPos的列名
var Column_PackTemplatePrintlst_VarPos = "VarPos"

//PackTemplatePrintlst.Picture的列名
var Column_PackTemplatePrintlst_Picture = "Picture"

//PackTemplatePrintlst.IsIdxToggle的列名
var Column_PackTemplatePrintlst_IsIdxToggle = "IsIdxToggle"

//PackTemplatePrintlst.KeyVal的列名
var Column_PackTemplatePrintlst_KeyVal = "KeyVal"

//PackTemplatePrintlst的指示器
var IndicatorOfPackTemplatePrintlst = &PackTemplatePrintlst{}

//创建PackTemplatePrintlst的游标
func BuildPackTemplatePrintlstCursor() *PackTemplatePrintlst {
	return &PackTemplatePrintlst{}
}

//查找指定键的PackTemplatePrintlst
func (self *DAO) SelectOnePackTemplatePrintlst(packTemplateId string, pos int) (*PackTemplatePrintlst, error) {
	var data PackTemplatePrintlst
	ok, err := self.session.Table("LOG_PackTemplatePrintlst").ID(core.PK{self.plantNr, packTemplateId, pos}).Get(&data)
	if err != nil {
		return nil, err
	}
	if !ok {
		return nil, err
	}
	return &data, nil
}

//删除指定键的PackTemplatePrintlst
func (self *DAO) DeleteOnePackTemplatePrintlst(packTemplateId string, pos int) error {
	_, err := self.session.Table("LOG_PackTemplatePrintlst").ID(core.PK{self.plantNr, packTemplateId, pos}).Delete(IndicatorOfPackTemplatePrintlst)
	if err != nil {
		return err
	}
	return nil
}

//批量检查PackTemplatePrintlst
func (self *DAO) checkPackTemplatePrintlstRecords(records *[]PackTemplatePrintlst) error {
	for _, record := range *records {
		if self.plantNr != record.PlantNr {
			return errors.New("记录不在范围内!")
		}
	}
	return nil
}

//插入多条PackTemplatePrintlst
func (self *DAO) InsertPackTemplatePrintlst(records *[]PackTemplatePrintlst) error {
	err := self.checkPackTemplatePrintlstRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("LOG_PackTemplatePrintlst").Insert(records)
	if err != nil {
		return err
	}
	return nil
}

//修改多条PackTemplatePrintlst
func (self *DAO) UpdatePackTemplatePrintlst(records *[]PackTemplatePrintlst) error {
	err := self.checkPackTemplatePrintlstRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("LOG_PackTemplatePrintlst").Cols("VarName", "VarValue", "VarType", "VarPos", "Picture", "IsIdxToggle", "KeyVal", "LastUser").Update(records)
	if err != nil {
		return err
	}
	return nil
}

//删除多条PackTemplatePrintlst
func (self *DAO) DeletePackTemplatePrintlst(records *[]PackTemplatePrintlst) error {
	err := self.checkPackTemplatePrintlstRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("LOG_PackTemplatePrintlst").Delete(records)
	if err != nil {
		return err
	}
	return nil
}

//按条件查询PackTemplatePrintlst
func (self *DAO) SelectPackTemplatePrintlst(predicates []grmi.Predicate) ([]PackTemplatePrintlst, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)
	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += " and " + predicate.ColumnName + " = ?"
			parameters = append(parameters, predicate.Value)
		}
	}
	data := make([]PackTemplatePrintlst, 0)
	err := self.session.Table("LOG_PackTemplatePrintlst").Where("PlantNr = ?"+where, parameters...).OrderBy("PlantNr").OrderBy("PackTemplateId").OrderBy("Pos").Find(&data)
	if err != nil {
		return nil, err
	}
	return data, nil
}

//按条件查询PackTemplatePrintlst并分页
func (self *DAO) SelectPackTemplatePrintlstAndPaging(pageSize int, pageIndex int, predicates []grmi.Predicate) (grmi.PagingResult, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)
	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += " and " + predicate.ColumnName + " = ?"
			parameters = append(parameters, predicate.Value)
		}
	}
	parameters = append(parameters, (pageIndex-1)*pageSize, pageSize)
	data := make([]PackTemplatePrintlst, 0)
	err := self.session.Table("LOG_PackTemplatePrintlst").SQL("select * from LOG_PackTemplatePrintlst where PlantNr = ?"+where+" order by PlantNr, PackTemplateId, Pos offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.PagingResult{}, err
	}
	count, err := self.session.Table("LOG_PackTemplatePrintlst").Where("PlantNr = ? ", self.plantNr).Count(IndicatorOfPackTemplatePrintlst)
	if err != nil {
		return grmi.PagingResult{}, err
	}
	return grmi.PagingResult{data, count, pageIndex, pageSize}, nil
}
