package qm

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	"xorm.io/core"
)

//QM_DefectGrpReasonLst的实体映射
type DefectGrpReasonLst struct {
	session        *xorm.Session `xorm:"-"`
	PlantNr        int           `xorm:"pk int 'PlantNr'" json:"QM_DefectGrpReasonLst-PlantNr"`
	DefectGrpId    string        `xorm:"pk nvarchar(20) 'DefectGrpId'" json:"QM_DefectGrpReasonLst-DefectGrpId"`
	DefectReasonId string        `xorm:"pk nvarchar(20) 'DefectReasonId'" json:"QM_DefectGrpReasonLst-DefectReasonId"`
	Pos            int           `xorm:"int 'pos' not null" json:"QM_DefectGrpReasonLst-pos"`
	LastModify     grmi.DateTime `xorm:"datetime 'LastModify' not null updated" json:"QM_DefectGrpReasonLst-LastModify"`
	LastUser       string        `xorm:"nvarchar(20) 'LastUser' not null" json:"QM_DefectGrpReasonLst-LastUser"`
	CreateTime     grmi.DateTime `xorm:"datetime 'CreateTime' not null created" json:"QM_DefectGrpReasonLst-CreateTime"`
}

var MetaOfDefectGrpReasonLst = map[string]grmi.Field{
	"defectgrpid":    {"DefectGrpId", "string"},
	"defectreasonid": {"DefectReasonId", "string"},
	"pos":            {"pos", "int"},
	"lastmodify":     {"LastModify", "grmi.DateTime"},
	"lastuser":       {"LastUser", "string"},
	"createtime":     {"CreateTime", "grmi.DateTime"},
}

//将DefectGrpReasonLst附加到xorm会话上
func (self *DefectGrpReasonLst) Attach(session *xorm.Session) *DefectGrpReasonLst {
	self.session = session
	return self
}

//插入DefectGrpReasonLst
func (self *DefectGrpReasonLst) Insert() error {
	_, err := self.session.Table("QM_DefectGrpReasonLst").Insert(self)
	if err != nil {
		return err
	}
	return nil
}

//修改DefectGrpReasonLst
func (self *DefectGrpReasonLst) Update() error {
	_, err := self.session.Table("QM_DefectGrpReasonLst").Cols("pos", "LastUser").Update(self)
	if err != nil {
		return err
	}
	return nil
}

//删除DefectGrpReasonLst
func (self *DefectGrpReasonLst) Delete() error {
	_, err := self.session.Table("QM_DefectGrpReasonLst").Delete(self)
	if err != nil {
		return err
	}
	return nil
}

//DefectGrpReasonLst的表名
var Table_DefectGrpReasonLst = "QM_DefectGrpReasonLst"

//DefectGrpReasonLst.DefectGrpId的列名
var Column_DefectGrpReasonLst_DefectGrpId = "DefectGrpId"

//DefectGrpReasonLst.DefectReasonId的列名
var Column_DefectGrpReasonLst_DefectReasonId = "DefectReasonId"

//DefectGrpReasonLst.Pos的列名
var Column_DefectGrpReasonLst_Pos = "pos"

//DefectGrpReasonLst的指示器
var IndicatorOfDefectGrpReasonLst = &DefectGrpReasonLst{}

//创建DefectGrpReasonLst的游标
func BuildDefectGrpReasonLstCursor() *DefectGrpReasonLst {
	return &DefectGrpReasonLst{}
}

//查找指定键的DefectGrpReasonLst
func (self *DAO) SelectOneDefectGrpReasonLst(defectGrpId string, defectReasonId string) (*DefectGrpReasonLst, error) {
	var data DefectGrpReasonLst
	ok, err := self.session.Table("QM_DefectGrpReasonLst").ID(core.PK{self.plantNr, defectGrpId, defectReasonId}).Get(&data)
	if err != nil {
		return nil, err
	}
	if !ok {
		return nil, err
	}
	return &data, nil
}

//删除指定键的DefectGrpReasonLst
func (self *DAO) DeleteOneDefectGrpReasonLst(defectGrpId string, defectReasonId string) error {
	_, err := self.session.Table("QM_DefectGrpReasonLst").ID(core.PK{self.plantNr, defectGrpId, defectReasonId}).Delete(IndicatorOfDefectGrpReasonLst)
	if err != nil {
		return err
	}
	return nil
}

//批量检查DefectGrpReasonLst
func (self *DAO) checkDefectGrpReasonLstRecords(records *[]DefectGrpReasonLst) error {
	for _, record := range *records {
		if self.plantNr != record.PlantNr {
			return errors.New("记录不在范围内!")
		}
	}
	return nil
}

//插入多条DefectGrpReasonLst
func (self *DAO) InsertDefectGrpReasonLst(records *[]DefectGrpReasonLst) error {
	err := self.checkDefectGrpReasonLstRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("QM_DefectGrpReasonLst").Insert(records)
	if err != nil {
		return err
	}
	return nil
}

//修改多条DefectGrpReasonLst
func (self *DAO) UpdateDefectGrpReasonLst(records *[]DefectGrpReasonLst) error {
	err := self.checkDefectGrpReasonLstRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("QM_DefectGrpReasonLst").Cols("pos", "LastUser").Update(records)
	if err != nil {
		return err
	}
	return nil
}

//删除多条DefectGrpReasonLst
func (self *DAO) DeleteDefectGrpReasonLst(records *[]DefectGrpReasonLst) error {
	err := self.checkDefectGrpReasonLstRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("QM_DefectGrpReasonLst").Delete(records)
	if err != nil {
		return err
	}
	return nil
}

//按条件查询DefectGrpReasonLst
func (self *DAO) SelectDefectGrpReasonLst(predicates []grmi.Predicate) ([]DefectGrpReasonLst, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)
	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += " and " + predicate.ColumnName + " = ?"
			parameters = append(parameters, predicate.Value)
		}
	}
	data := make([]DefectGrpReasonLst, 0)
	err := self.session.Table("QM_DefectGrpReasonLst").Where("PlantNr = ?"+where, parameters...).OrderBy("PlantNr").OrderBy("DefectGrpId").OrderBy("DefectReasonId").Find(&data)
	if err != nil {
		return nil, err
	}
	return data, nil
}

//按条件查询DefectGrpReasonLst并分页
func (self *DAO) SelectDefectGrpReasonLstAndPaging(pageSize int, pageIndex int, predicates []grmi.Predicate) (grmi.PagingResult, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)
	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += " and " + predicate.ColumnName + " = ?"
			parameters = append(parameters, predicate.Value)
		}
	}
	parameters = append(parameters, (pageIndex-1)*pageSize, pageSize)
	data := make([]DefectGrpReasonLst, 0)
	err := self.session.Table("QM_DefectGrpReasonLst").SQL("select * from QM_DefectGrpReasonLst where PlantNr = ?"+where+" order by PlantNr, DefectGrpId, DefectReasonId offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.PagingResult{}, err
	}
	count, err := self.session.Table("QM_DefectGrpReasonLst").Where("PlantNr = ? ", self.plantNr).Count(IndicatorOfDefectGrpReasonLst)
	if err != nil {
		return grmi.PagingResult{}, err
	}
	return grmi.PagingResult{data, count, pageIndex, pageSize}, nil
}
