package qm

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	"xorm.io/core"
)

//QM_DefectRecord的实体映射
type DefectRecord struct {
	session        *xorm.Session `xorm:"-"`
	PlantNr        int           `xorm:"pk int 'PlantNr'" json:"QM_DefectRecord-PlantNr"`
	RecNr          int           `xorm:"pk int 'RecNr'" json:"QM_DefectRecord-RecNr"`
	SerialOrderId  string        `xorm:"nvarchar(40) 'SerialOrderId' not null" json:"QM_DefectRecord-SerialOrderId"`
	OperationNr    int           `xorm:"int 'OperationNr' not null" json:"QM_DefectRecord-OperationNr"`
	Qty            int           `xorm:"int 'qty' not null" json:"QM_DefectRecord-qty"`
	ViewId         string        `xorm:"nvarchar(20) 'ViewId' not null" json:"QM_DefectRecord-ViewId"`
	ViewDescr      string        `xorm:"nvarchar(100) 'ViewDescr' not null" json:"QM_DefectRecord-ViewDescr"`
	ViewPicture    string        `xorm:"nvarchar(1000) 'ViewPicture' not null" json:"QM_DefectRecord-ViewPicture"`
	ViewCode       int           `xorm:"int 'ViewCode' not null" json:"QM_DefectRecord-ViewCode"`
	Width          int           `xorm:"int 'Width' not null" json:"QM_DefectRecord-Width"`
	Height         int           `xorm:"int 'Height' not null" json:"QM_DefectRecord-Height"`
	EndProduct     string        `xorm:"nvarchar(40) 'EndProduct' not null" json:"QM_DefectRecord-EndProduct"`
	AreaId         int           `xorm:"int 'AreaId' not null" json:"QM_DefectRecord-AreaId"`
	XStart         int           `xorm:"int 'XStart' not null" json:"QM_DefectRecord-XStart"`
	XEnd           int           `xorm:"int 'XEnd' not null" json:"QM_DefectRecord-XEnd"`
	YStart         int           `xorm:"int 'YStart' not null" json:"QM_DefectRecord-YStart"`
	YEnd           int           `xorm:"int 'YEnd' not null" json:"QM_DefectRecord-YEnd"`
	XPos           int           `xorm:"int 'XPos' not null" json:"QM_DefectRecord-XPos"`
	YPos           int           `xorm:"int 'YPos' not null" json:"QM_DefectRecord-YPos"`
	WorkplaceId    string        `xorm:"nvarchar(20) 'WorkplaceId' not null" json:"QM_DefectRecord-WorkplaceId"`
	ReworkplaceId  string        `xorm:"nvarchar(20) 'ReworkplaceId' not null" json:"QM_DefectRecord-ReworkplaceId"`
	Status         string        `xorm:"nvarchar(2) 'status' not null" json:"QM_DefectRecord-status"`
	DefectGrpId    string        `xorm:"nvarchar(20) 'DefectGrpId' not null" json:"QM_DefectRecord-DefectGrpId"`
	DefectGrpDescr string        `xorm:"nvarchar(100) 'DefectGrpDescr' not null" json:"QM_DefectRecord-DefectGrpDescr"`
	DefectReasonId string        `xorm:"nvarchar(20) 'DefectReasonId' not null" json:"QM_DefectRecord-DefectReasonId"`
	DefectDescr    string        `xorm:"nvarchar(100) 'DefectDescr' not null" json:"QM_DefectRecord-DefectDescr"`
	InspectTime    grmi.DateTime `xorm:"datetime 'InspectTime' not null" json:"QM_DefectRecord-InspectTime"`
	InspectShiftId string        `xorm:"nvarchar(20) 'InspectShiftId' not null" json:"QM_DefectRecord-InspectShiftId"`
	Inspector      string        `xorm:"nvarchar(20) 'Inspector' not null" json:"QM_DefectRecord-Inspector"`
	ReworkTime     grmi.DateTime `xorm:"datetime 'ReworkTime' not null" json:"QM_DefectRecord-ReworkTime"`
	ReworkShiftId  string        `xorm:"nvarchar(20) 'ReworkShiftId' not null" json:"QM_DefectRecord-ReworkShiftId"`
	Reworker       string        `xorm:"nvarchar(20) 'Reworker' not null" json:"QM_DefectRecord-Reworker"`
	BuildCode      string        `xorm:"nvarchar(100) 'BuildCode' not null" json:"QM_DefectRecord-BuildCode"`
	DDCCustC1      string        `xorm:"nvarchar(40) 'DDC_CustC1' not null" json:"QM_DefectRecord-DDC_CustC1"`
	DDCCustC2      string        `xorm:"nvarchar(40) 'DDC_CustC2' not null" json:"QM_DefectRecord-DDC_CustC2"`
	DDCCustC3      string        `xorm:"nvarchar(40) 'DDC_CustC3' not null" json:"QM_DefectRecord-DDC_CustC3"`
	DDCCustC4      string        `xorm:"nvarchar(40) 'DDC_CustC4' not null" json:"QM_DefectRecord-DDC_CustC4"`
	DDCCustI1      int           `xorm:"int 'DDC_CustI1' not null" json:"QM_DefectRecord-DDC_CustI1"`
	DDCCustI2      int           `xorm:"int 'DDC_CustI2' not null" json:"QM_DefectRecord-DDC_CustI2"`
	DDCCustI3      int           `xorm:"int 'DDC_CustI3' not null" json:"QM_DefectRecord-DDC_CustI3"`
	DDCCustI4      int           `xorm:"int 'DDC_CustI4' not null" json:"QM_DefectRecord-DDC_CustI4"`
	DDCCustT1      grmi.DateTime `xorm:"datetime 'DDC_CustT1'" json:"QM_DefectRecord-DDC_CustT1"`
	DDCCustT2      grmi.DateTime `xorm:"datetime 'DDC_CustT2'" json:"QM_DefectRecord-DDC_CustT2"`
	LastModify     grmi.DateTime `xorm:"datetime 'LastModify' not null updated" json:"QM_DefectRecord-LastModify"`
	LastUser       string        `xorm:"nvarchar(20) 'LastUser' not null" json:"QM_DefectRecord-LastUser"`
	CreateTime     grmi.DateTime `xorm:"datetime 'CreateTime' not null created" json:"QM_DefectRecord-CreateTime"`
}

var MetaOfDefectRecord = map[string]grmi.Field{
	"recnr":          {"RecNr", "int"},
	"serialorderid":  {"SerialOrderId", "string"},
	"operationnr":    {"OperationNr", "int"},
	"qty":            {"qty", "int"},
	"viewid":         {"ViewId", "string"},
	"viewdescr":      {"ViewDescr", "string"},
	"viewpicture":    {"ViewPicture", "string"},
	"viewcode":       {"ViewCode", "int"},
	"width":          {"Width", "int"},
	"height":         {"Height", "int"},
	"endproduct":     {"EndProduct", "string"},
	"areaid":         {"AreaId", "int"},
	"xstart":         {"XStart", "int"},
	"xend":           {"XEnd", "int"},
	"ystart":         {"YStart", "int"},
	"yend":           {"YEnd", "int"},
	"xpos":           {"XPos", "int"},
	"ypos":           {"YPos", "int"},
	"workplaceid":    {"WorkplaceId", "string"},
	"reworkplaceid":  {"ReworkplaceId", "string"},
	"status":         {"status", "string"},
	"defectgrpid":    {"DefectGrpId", "string"},
	"defectgrpdescr": {"DefectGrpDescr", "string"},
	"defectreasonid": {"DefectReasonId", "string"},
	"defectdescr":    {"DefectDescr", "string"},
	"inspecttime":    {"InspectTime", "grmi.DateTime"},
	"inspectshiftid": {"InspectShiftId", "string"},
	"inspector":      {"Inspector", "string"},
	"reworktime":     {"ReworkTime", "grmi.DateTime"},
	"reworkshiftid":  {"ReworkShiftId", "string"},
	"reworker":       {"Reworker", "string"},
	"buildcode":      {"BuildCode", "string"},
	"ddccustc1":      {"DDC_CustC1", "string"},
	"ddccustc2":      {"DDC_CustC2", "string"},
	"ddccustc3":      {"DDC_CustC3", "string"},
	"ddccustc4":      {"DDC_CustC4", "string"},
	"ddccusti1":      {"DDC_CustI1", "int"},
	"ddccusti2":      {"DDC_CustI2", "int"},
	"ddccusti3":      {"DDC_CustI3", "int"},
	"ddccusti4":      {"DDC_CustI4", "int"},
	"ddccustt1":      {"DDC_CustT1", "grmi.DateTime"},
	"ddccustt2":      {"DDC_CustT2", "grmi.DateTime"},
	"lastmodify":     {"LastModify", "grmi.DateTime"},
	"lastuser":       {"LastUser", "string"},
	"createtime":     {"CreateTime", "grmi.DateTime"},
}

//将DefectRecord附加到xorm会话上
func (self *DefectRecord) Attach(session *xorm.Session) *DefectRecord {
	self.session = session
	return self
}

//插入DefectRecord
func (self *DefectRecord) Insert() error {
	_, err := self.session.Table("QM_DefectRecord").Insert(self)
	if err != nil {
		return err
	}
	return nil
}

//修改DefectRecord
func (self *DefectRecord) Update() error {
	_, err := self.session.Table("QM_DefectRecord").Cols("SerialOrderId", "OperationNr", "qty", "ViewId", "ViewDescr", "ViewPicture", "ViewCode", "Width", "Height", "EndProduct", "AreaId", "XStart", "XEnd", "YStart", "YEnd", "XPos", "YPos", "WorkplaceId", "ReworkplaceId", "status", "DefectGrpId", "DefectGrpDescr", "DefectReasonId", "DefectDescr", "InspectTime", "InspectShiftId", "Inspector", "ReworkTime", "ReworkShiftId", "Reworker", "BuildCode", "DDC_CustC1", "DDC_CustC2", "DDC_CustC3", "DDC_CustC4", "DDC_CustI1", "DDC_CustI2", "DDC_CustI3", "DDC_CustI4", "DDC_CustT1", "DDC_CustT2", "LastUser").Update(self)
	if err != nil {
		return err
	}
	return nil
}

//删除DefectRecord
func (self *DefectRecord) Delete() error {
	_, err := self.session.Table("QM_DefectRecord").Delete(self)
	if err != nil {
		return err
	}
	return nil
}

//DefectRecord的表名
var Table_DefectRecord = "QM_DefectRecord"

//DefectRecord.RecNr的列名
var Column_DefectRecord_RecNr = "RecNr"

//DefectRecord.SerialOrderId的列名
var Column_DefectRecord_SerialOrderId = "SerialOrderId"

//DefectRecord.OperationNr的列名
var Column_DefectRecord_OperationNr = "OperationNr"

//DefectRecord.Qty的列名
var Column_DefectRecord_Qty = "qty"

//DefectRecord.ViewId的列名
var Column_DefectRecord_ViewId = "ViewId"

//DefectRecord.ViewDescr的列名
var Column_DefectRecord_ViewDescr = "ViewDescr"

//DefectRecord.ViewPicture的列名
var Column_DefectRecord_ViewPicture = "ViewPicture"

//DefectRecord.ViewCode的列名
var Column_DefectRecord_ViewCode = "ViewCode"

//DefectRecord.Width的列名
var Column_DefectRecord_Width = "Width"

//DefectRecord.Height的列名
var Column_DefectRecord_Height = "Height"

//DefectRecord.EndProduct的列名
var Column_DefectRecord_EndProduct = "EndProduct"

//DefectRecord.AreaId的列名
var Column_DefectRecord_AreaId = "AreaId"

//DefectRecord.XStart的列名
var Column_DefectRecord_XStart = "XStart"

//DefectRecord.XEnd的列名
var Column_DefectRecord_XEnd = "XEnd"

//DefectRecord.YStart的列名
var Column_DefectRecord_YStart = "YStart"

//DefectRecord.YEnd的列名
var Column_DefectRecord_YEnd = "YEnd"

//DefectRecord.XPos的列名
var Column_DefectRecord_XPos = "XPos"

//DefectRecord.YPos的列名
var Column_DefectRecord_YPos = "YPos"

//DefectRecord.WorkplaceId的列名
var Column_DefectRecord_WorkplaceId = "WorkplaceId"

//DefectRecord.ReworkplaceId的列名
var Column_DefectRecord_ReworkplaceId = "ReworkplaceId"

//DefectRecord.Status的列名
var Column_DefectRecord_Status = "status"

//DefectRecord.DefectGrpId的列名
var Column_DefectRecord_DefectGrpId = "DefectGrpId"

//DefectRecord.DefectGrpDescr的列名
var Column_DefectRecord_DefectGrpDescr = "DefectGrpDescr"

//DefectRecord.DefectReasonId的列名
var Column_DefectRecord_DefectReasonId = "DefectReasonId"

//DefectRecord.DefectDescr的列名
var Column_DefectRecord_DefectDescr = "DefectDescr"

//DefectRecord.InspectTime的列名
var Column_DefectRecord_InspectTime = "InspectTime"

//DefectRecord.InspectShiftId的列名
var Column_DefectRecord_InspectShiftId = "InspectShiftId"

//DefectRecord.Inspector的列名
var Column_DefectRecord_Inspector = "Inspector"

//DefectRecord.ReworkTime的列名
var Column_DefectRecord_ReworkTime = "ReworkTime"

//DefectRecord.ReworkShiftId的列名
var Column_DefectRecord_ReworkShiftId = "ReworkShiftId"

//DefectRecord.Reworker的列名
var Column_DefectRecord_Reworker = "Reworker"

//DefectRecord.BuildCode的列名
var Column_DefectRecord_BuildCode = "BuildCode"

//DefectRecord.DDCCustC1的列名
var Column_DefectRecord_DDCCustC1 = "DDC_CustC1"

//DefectRecord.DDCCustC2的列名
var Column_DefectRecord_DDCCustC2 = "DDC_CustC2"

//DefectRecord.DDCCustC3的列名
var Column_DefectRecord_DDCCustC3 = "DDC_CustC3"

//DefectRecord.DDCCustC4的列名
var Column_DefectRecord_DDCCustC4 = "DDC_CustC4"

//DefectRecord.DDCCustI1的列名
var Column_DefectRecord_DDCCustI1 = "DDC_CustI1"

//DefectRecord.DDCCustI2的列名
var Column_DefectRecord_DDCCustI2 = "DDC_CustI2"

//DefectRecord.DDCCustI3的列名
var Column_DefectRecord_DDCCustI3 = "DDC_CustI3"

//DefectRecord.DDCCustI4的列名
var Column_DefectRecord_DDCCustI4 = "DDC_CustI4"

//DefectRecord.DDCCustT1的列名
var Column_DefectRecord_DDCCustT1 = "DDC_CustT1"

//DefectRecord.DDCCustT2的列名
var Column_DefectRecord_DDCCustT2 = "DDC_CustT2"

//DefectRecord的指示器
var IndicatorOfDefectRecord = &DefectRecord{}

//创建DefectRecord的游标
func BuildDefectRecordCursor() *DefectRecord {
	return &DefectRecord{}
}

//查找指定键的DefectRecord
func (self *DAO) SelectOneDefectRecord(recNr int) (*DefectRecord, error) {
	var data DefectRecord
	ok, err := self.session.Table("QM_DefectRecord").ID(core.PK{self.plantNr, recNr}).Get(&data)
	if err != nil {
		return nil, err
	}
	if !ok {
		return nil, err
	}
	return &data, nil
}

//删除指定键的DefectRecord
func (self *DAO) DeleteOneDefectRecord(recNr int) error {
	_, err := self.session.Table("QM_DefectRecord").ID(core.PK{self.plantNr, recNr}).Delete(IndicatorOfDefectRecord)
	if err != nil {
		return err
	}
	return nil
}

//批量检查DefectRecord
func (self *DAO) checkDefectRecordRecords(records *[]DefectRecord) error {
	for _, record := range *records {
		if self.plantNr != record.PlantNr {
			return errors.New("记录不在范围内!")
		}
	}
	return nil
}

//插入多条DefectRecord
func (self *DAO) InsertDefectRecord(records *[]DefectRecord) error {
	err := self.checkDefectRecordRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("QM_DefectRecord").Insert(records)
	if err != nil {
		return err
	}
	return nil
}

//修改多条DefectRecord
func (self *DAO) UpdateDefectRecord(records *[]DefectRecord) error {
	err := self.checkDefectRecordRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("QM_DefectRecord").Cols("SerialOrderId", "OperationNr", "qty", "ViewId", "ViewDescr", "ViewPicture", "ViewCode", "Width", "Height", "EndProduct", "AreaId", "XStart", "XEnd", "YStart", "YEnd", "XPos", "YPos", "WorkplaceId", "ReworkplaceId", "status", "DefectGrpId", "DefectGrpDescr", "DefectReasonId", "DefectDescr", "InspectTime", "InspectShiftId", "Inspector", "ReworkTime", "ReworkShiftId", "Reworker", "BuildCode", "DDC_CustC1", "DDC_CustC2", "DDC_CustC3", "DDC_CustC4", "DDC_CustI1", "DDC_CustI2", "DDC_CustI3", "DDC_CustI4", "DDC_CustT1", "DDC_CustT2", "LastUser").Update(records)
	if err != nil {
		return err
	}
	return nil
}

//删除多条DefectRecord
func (self *DAO) DeleteDefectRecord(records *[]DefectRecord) error {
	err := self.checkDefectRecordRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("QM_DefectRecord").Delete(records)
	if err != nil {
		return err
	}
	return nil
}

//按条件查询DefectRecord
func (self *DAO) SelectDefectRecord(predicates []grmi.Predicate) ([]DefectRecord, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)
	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += " and " + predicate.ColumnName + " = ?"
			parameters = append(parameters, predicate.Value)
		}
	}
	data := make([]DefectRecord, 0)
	err := self.session.Table("QM_DefectRecord").Where("PlantNr = ?"+where, parameters...).OrderBy("PlantNr").OrderBy("RecNr").Find(&data)
	if err != nil {
		return nil, err
	}
	return data, nil
}

//按条件查询DefectRecord并分页
func (self *DAO) SelectDefectRecordAndPaging(pageSize int, pageIndex int, predicates []grmi.Predicate) (grmi.PagingResult, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)
	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += " and " + predicate.ColumnName + " = ?"
			parameters = append(parameters, predicate.Value)
		}
	}
	parameters = append(parameters, (pageIndex-1)*pageSize, pageSize)
	data := make([]DefectRecord, 0)
	err := self.session.Table("QM_DefectRecord").SQL("select * from QM_DefectRecord where PlantNr = ?"+where+" order by PlantNr, RecNr offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.PagingResult{}, err
	}
	count, err := self.session.Table("QM_DefectRecord").Where("PlantNr = ? ", self.plantNr).Count(IndicatorOfDefectRecord)
	if err != nil {
		return grmi.PagingResult{}, err
	}
	return grmi.PagingResult{data, count, pageIndex, pageSize}, nil
}
