package qm

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	"xorm.io/core"
)

//QM_ViewDefectGrplst的实体映射
type ViewDefectGrplst struct {
	session     *xorm.Session `xorm:"-"`
	PlantNr     int           `xorm:"pk int 'PlantNr'" json:"QM_ViewDefectGrplst-PlantNr"`
	ViewId      string        `xorm:"pk nvarchar(20) 'ViewId'" json:"QM_ViewDefectGrplst-ViewId"`
	DefectGrpId string        `xorm:"pk nvarchar(20) 'DefectGrpId'" json:"QM_ViewDefectGrplst-DefectGrpId"`
	Pos         int           `xorm:"int 'Pos' not null" json:"QM_ViewDefectGrplst-Pos"`
	LastModify  grmi.DateTime `xorm:"datetime 'LastModify' not null updated" json:"QM_ViewDefectGrplst-LastModify"`
	LastUser    string        `xorm:"nvarchar(20) 'LastUser' not null" json:"QM_ViewDefectGrplst-LastUser"`
	CreateTime  grmi.DateTime `xorm:"datetime 'CreateTime' not null created" json:"QM_ViewDefectGrplst-CreateTime"`
}

var MetaOfViewDefectGrplst = map[string]grmi.Field{
	"viewid":      {"ViewId", "string"},
	"defectgrpid": {"DefectGrpId", "string"},
	"pos":         {"Pos", "int"},
	"lastmodify":  {"LastModify", "grmi.DateTime"},
	"lastuser":    {"LastUser", "string"},
	"createtime":  {"CreateTime", "grmi.DateTime"},
}

//将ViewDefectGrplst附加到xorm会话上
func (self *ViewDefectGrplst) Attach(session *xorm.Session) *ViewDefectGrplst {
	self.session = session
	return self
}

//插入ViewDefectGrplst
func (self *ViewDefectGrplst) Insert() error {
	_, err := self.session.Table("QM_ViewDefectGrplst").Insert(self)
	if err != nil {
		return err
	}
	return nil
}

//修改ViewDefectGrplst
func (self *ViewDefectGrplst) Update() error {
	_, err := self.session.Table("QM_ViewDefectGrplst").Cols("Pos", "LastUser").Update(self)
	if err != nil {
		return err
	}
	return nil
}

//删除ViewDefectGrplst
func (self *ViewDefectGrplst) Delete() error {
	_, err := self.session.Table("QM_ViewDefectGrplst").Delete(self)
	if err != nil {
		return err
	}
	return nil
}

//ViewDefectGrplst的表名
var Table_ViewDefectGrplst = "QM_ViewDefectGrplst"

//ViewDefectGrplst.ViewId的列名
var Column_ViewDefectGrplst_ViewId = "ViewId"

//ViewDefectGrplst.DefectGrpId的列名
var Column_ViewDefectGrplst_DefectGrpId = "DefectGrpId"

//ViewDefectGrplst.Pos的列名
var Column_ViewDefectGrplst_Pos = "Pos"

//ViewDefectGrplst的指示器
var IndicatorOfViewDefectGrplst = &ViewDefectGrplst{}

//创建ViewDefectGrplst的游标
func BuildViewDefectGrplstCursor() *ViewDefectGrplst {
	return &ViewDefectGrplst{}
}

//查找指定键的ViewDefectGrplst
func (self *DAO) SelectOneViewDefectGrplst(viewId string, defectGrpId string) (*ViewDefectGrplst, error) {
	var data ViewDefectGrplst
	ok, err := self.session.Table("QM_ViewDefectGrplst").ID(core.PK{self.plantNr, viewId, defectGrpId}).Get(&data)
	if err != nil {
		return nil, err
	}
	if !ok {
		return nil, err
	}
	return &data, nil
}

//删除指定键的ViewDefectGrplst
func (self *DAO) DeleteOneViewDefectGrplst(viewId string, defectGrpId string) error {
	_, err := self.session.Table("QM_ViewDefectGrplst").ID(core.PK{self.plantNr, viewId, defectGrpId}).Delete(IndicatorOfViewDefectGrplst)
	if err != nil {
		return err
	}
	return nil
}

//批量检查ViewDefectGrplst
func (self *DAO) checkViewDefectGrplstRecords(records *[]ViewDefectGrplst) error {
	for _, record := range *records {
		if self.plantNr != record.PlantNr {
			return errors.New("记录不在范围内!")
		}
	}
	return nil
}

//插入多条ViewDefectGrplst
func (self *DAO) InsertViewDefectGrplst(records *[]ViewDefectGrplst) error {
	err := self.checkViewDefectGrplstRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("QM_ViewDefectGrplst").Insert(records)
	if err != nil {
		return err
	}
	return nil
}

//修改多条ViewDefectGrplst
func (self *DAO) UpdateViewDefectGrplst(records *[]ViewDefectGrplst) error {
	err := self.checkViewDefectGrplstRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("QM_ViewDefectGrplst").Cols("Pos", "LastUser").Update(records)
	if err != nil {
		return err
	}
	return nil
}

//删除多条ViewDefectGrplst
func (self *DAO) DeleteViewDefectGrplst(records *[]ViewDefectGrplst) error {
	err := self.checkViewDefectGrplstRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("QM_ViewDefectGrplst").Delete(records)
	if err != nil {
		return err
	}
	return nil
}

//按条件查询ViewDefectGrplst
func (self *DAO) SelectViewDefectGrplst(predicates []grmi.Predicate) ([]ViewDefectGrplst, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)
	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += " and " + predicate.ColumnName + " = ?"
			parameters = append(parameters, predicate.Value)
		}
	}
	data := make([]ViewDefectGrplst, 0)
	err := self.session.Table("QM_ViewDefectGrplst").Where("PlantNr = ?"+where, parameters...).OrderBy("PlantNr").OrderBy("ViewId").OrderBy("DefectGrpId").Find(&data)
	if err != nil {
		return nil, err
	}
	return data, nil
}

//按条件查询ViewDefectGrplst并分页
func (self *DAO) SelectViewDefectGrplstAndPaging(pageSize int, pageIndex int, predicates []grmi.Predicate) (grmi.PagingResult, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)
	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += " and " + predicate.ColumnName + " = ?"
			parameters = append(parameters, predicate.Value)
		}
	}
	parameters = append(parameters, (pageIndex-1)*pageSize, pageSize)
	data := make([]ViewDefectGrplst, 0)
	err := self.session.Table("QM_ViewDefectGrplst").SQL("select * from QM_ViewDefectGrplst where PlantNr = ?"+where+" order by PlantNr, ViewId, DefectGrpId offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.PagingResult{}, err
	}
	count, err := self.session.Table("QM_ViewDefectGrplst").Where("PlantNr = ? ", self.plantNr).Count(IndicatorOfViewDefectGrplst)
	if err != nil {
		return grmi.PagingResult{}, err
	}
	return grmi.PagingResult{data, count, pageIndex, pageSize}, nil
}
