package qm

import (
	"errors"
	"github.com/go-xorm/xorm"
	"leit.com/LAPP_GAAS_GFrame/grmi"
	"xorm.io/core"
)

//QM_ViewDefectlst的实体映射
type ViewDefectlst struct {
	session        *xorm.Session `xorm:"-"`
	PlantNr        int           `xorm:"pk int 'PlantNr'" json:"QM_ViewDefectlst-PlantNr"`
	ViewId         string        `xorm:"pk nvarchar(20) 'ViewId'" json:"QM_ViewDefectlst-ViewId"`
	DefectReasonId string        `xorm:"pk nvarchar(20) 'DefectReasonId'" json:"QM_ViewDefectlst-DefectReasonId"`
	Pos            int           `xorm:"int 'Pos' not null" json:"QM_ViewDefectlst-Pos"`
	LastModify     grmi.DateTime `xorm:"datetime 'LastModify' not null updated" json:"QM_ViewDefectlst-LastModify"`
	LastUser       string        `xorm:"nvarchar(20) 'LastUser' not null" json:"QM_ViewDefectlst-LastUser"`
	CreateTime     grmi.DateTime `xorm:"datetime 'CreateTime' not null created" json:"QM_ViewDefectlst-CreateTime"`
}

var MetaOfViewDefectlst = map[string]grmi.Field{
	"viewid":         {"ViewId", "string"},
	"defectreasonid": {"DefectReasonId", "string"},
	"pos":            {"Pos", "int"},
	"lastmodify":     {"LastModify", "grmi.DateTime"},
	"lastuser":       {"LastUser", "string"},
	"createtime":     {"CreateTime", "grmi.DateTime"},
}

//将ViewDefectlst附加到xorm会话上
func (self *ViewDefectlst) Attach(session *xorm.Session) *ViewDefectlst {
	self.session = session
	return self
}

//插入ViewDefectlst
func (self *ViewDefectlst) Insert() error {
	_, err := self.session.Table("QM_ViewDefectlst").Insert(self)
	if err != nil {
		return err
	}
	return nil
}

//修改ViewDefectlst
func (self *ViewDefectlst) Update() error {
	_, err := self.session.Table("QM_ViewDefectlst").Cols("Pos", "LastUser").Update(self)
	if err != nil {
		return err
	}
	return nil
}

//删除ViewDefectlst
func (self *ViewDefectlst) Delete() error {
	_, err := self.session.Table("QM_ViewDefectlst").Delete(self)
	if err != nil {
		return err
	}
	return nil
}

//ViewDefectlst的表名
var Table_ViewDefectlst = "QM_ViewDefectlst"

//ViewDefectlst.ViewId的列名
var Column_ViewDefectlst_ViewId = "ViewId"

//ViewDefectlst.DefectReasonId的列名
var Column_ViewDefectlst_DefectReasonId = "DefectReasonId"

//ViewDefectlst.Pos的列名
var Column_ViewDefectlst_Pos = "Pos"

//ViewDefectlst的指示器
var IndicatorOfViewDefectlst = &ViewDefectlst{}

//创建ViewDefectlst的游标
func BuildViewDefectlstCursor() *ViewDefectlst {
	return &ViewDefectlst{}
}

//查找指定键的ViewDefectlst
func (self *DAO) SelectOneViewDefectlst(viewId string, defectReasonId string) (*ViewDefectlst, error) {
	var data ViewDefectlst
	ok, err := self.session.Table("QM_ViewDefectlst").ID(core.PK{self.plantNr, viewId, defectReasonId}).Get(&data)
	if err != nil {
		return nil, err
	}
	if !ok {
		return nil, err
	}
	return &data, nil
}

//删除指定键的ViewDefectlst
func (self *DAO) DeleteOneViewDefectlst(viewId string, defectReasonId string) error {
	_, err := self.session.Table("QM_ViewDefectlst").ID(core.PK{self.plantNr, viewId, defectReasonId}).Delete(IndicatorOfViewDefectlst)
	if err != nil {
		return err
	}
	return nil
}

//批量检查ViewDefectlst
func (self *DAO) checkViewDefectlstRecords(records *[]ViewDefectlst) error {
	for _, record := range *records {
		if self.plantNr != record.PlantNr {
			return errors.New("记录不在范围内!")
		}
	}
	return nil
}

//插入多条ViewDefectlst
func (self *DAO) InsertViewDefectlst(records *[]ViewDefectlst) error {
	err := self.checkViewDefectlstRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("QM_ViewDefectlst").Insert(records)
	if err != nil {
		return err
	}
	return nil
}

//修改多条ViewDefectlst
func (self *DAO) UpdateViewDefectlst(records *[]ViewDefectlst) error {
	err := self.checkViewDefectlstRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("QM_ViewDefectlst").Cols("Pos", "LastUser").Update(records)
	if err != nil {
		return err
	}
	return nil
}

//删除多条ViewDefectlst
func (self *DAO) DeleteViewDefectlst(records *[]ViewDefectlst) error {
	err := self.checkViewDefectlstRecords(records)
	if err != nil {
		return err
	}
	_, err = self.session.Table("QM_ViewDefectlst").Delete(records)
	if err != nil {
		return err
	}
	return nil
}

//按条件查询ViewDefectlst
func (self *DAO) SelectViewDefectlst(predicates []grmi.Predicate) ([]ViewDefectlst, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)
	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += " and " + predicate.ColumnName + " = ?"
			parameters = append(parameters, predicate.Value)
		}
	}
	data := make([]ViewDefectlst, 0)
	err := self.session.Table("QM_ViewDefectlst").Where("PlantNr = ?"+where, parameters...).OrderBy("PlantNr").OrderBy("ViewId").OrderBy("DefectReasonId").Find(&data)
	if err != nil {
		return nil, err
	}
	return data, nil
}

//按条件查询ViewDefectlst并分页
func (self *DAO) SelectViewDefectlstAndPaging(pageSize int, pageIndex int, predicates []grmi.Predicate) (grmi.PagingResult, error) {
	parameters := make([]interface{}, 0, 10)
	parameters = append(parameters, self.plantNr)
	where := ""
	if predicates != nil {
		for _, predicate := range predicates {
			where += " and " + predicate.ColumnName + " = ?"
			parameters = append(parameters, predicate.Value)
		}
	}
	parameters = append(parameters, (pageIndex-1)*pageSize, pageSize)
	data := make([]ViewDefectlst, 0)
	err := self.session.Table("QM_ViewDefectlst").SQL("select * from QM_ViewDefectlst where PlantNr = ?"+where+" order by PlantNr, ViewId, DefectReasonId offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.PagingResult{}, err
	}
	count, err := self.session.Table("QM_ViewDefectlst").Where("PlantNr = ? ", self.plantNr).Count(IndicatorOfViewDefectlst)
	if err != nil {
		return grmi.PagingResult{}, err
	}
	return grmi.PagingResult{data, count, pageIndex, pageSize}, nil
}
